if ModSettingGet("SpicyTP.do_actions") then
    local path = "mods/SpicyTP/files/ui_gfx/gun_actions/"
    local actions_to_edit = {
        ["ACCELERATING_SHOT"                    ] = true,
        ["ACIDSHOT"                             ] = true,
        ["ADD_DEATH_TRIGGER"                    ] = true,
        ["ACID_TRAIL"                           ] = true,
        ["AIR_BULLET"                           ] = true,
        ["ALCOHOL_BLAST"                        ] = true,
        ["ALL_ACID"                             ] = true,
        ["ALL_BLACKHOLES"                       ] = true,
        ["ALL_DEATHCROSSES"                     ] = true,
        ["ALL_DISCS"                            ] = true,
        ["ALL_NUKES"                            ] = true,
        ["ALL_ROCKETS"                          ] = true,
        ["ALL_SPELLS"                           ] = true,
        ["ALPHA"                                ] = true,
        ["ARC_ELECTRIC"                         ] = true,
        ["ARC_FIRE"                             ] = true,
        ["ARC_GUNPOWDER"                        ] = true,
        ["ARC_POISON"                           ] = true,
        ["AREA_DAMAGE"                          ] = true,
        ["ARROW"                                ] = true,
        ["AUTOAIM"                              ] = true,
        ["AVOIDING_ARC"                         ] = true,
        ["BALL_LIGHTNING"                       ] = true,
        ["BERSERK_FIELD"                        ] = true,
        ["BIG_MAGIC_SHIELD"                     ] = true,
        ["BLACK_HOLE"                           ] = true,
        ["BLACK_HOLE_BIG"                       ] = true,
        ["BLACK_HOLE_DEATH_TRIGGER"             ] = true,
        ["BLACK_HOLE_GIGA"                      ] = true,
        ["BLOODLUST"                            ] = true,
        ["BLOOD_MAGIC"                          ] = true,
        ["BLOOD_TO_ACID"                        ] = true,
        ["BLOOD_TO_POWER"                       ] = true,
        ["BOMB"                                 ] = true,
        ["BOMB_CART"                            ] = true,
        ["BOMB_DETONATOR"                       ] = true,
        ["BOMB_HOLY"                            ] = true,
        ["BOMB_HOLY_GIGA"                       ] = true,
        ["BOUNCE"                               ] = true,
        ["BOUNCE_EXPLOSION"                     ] = true,
        ["BOUNCE_LARPA"                         ] = true,
        ["BOUNCE_LASER"                         ] = true,
        ["BOUNCE_LASER_EMITTER"                 ] = true,
        ["BOUNCE_SPARK"                         ] = true,
        ["BOUNCY_ORB"                           ] = true,
        ["BOUNCY_ORB_TIMER"                     ] = true,
        ["BUBBLESHOT"                           ] = true,
        ["BUBBLESHOT_TRIGGER"                   ] = true,
        ["BUCKSHOT"                             ] = true,
        ["BULLET"                               ] = true,
        ["BULLET_TIMER"                         ] = true,
        ["BULLET_TRIGGER"                       ] = true,
        ["BURN_TRAIL"                           ] = true,
        ["BURST_2"                              ] = true,
        ["BURST_3"                              ] = true,
        ["BURST_4"                              ] = true,
        ["BURST_8"                              ] = true,
        ["BURST_X"                              ] = true,
        ["CHAINSAW"                             ] = true,
        ["CHAIN_BOLT"                           ] = true,
        ["CHAIN_SHOT"                           ] = true,
        ["CHAOS_POLYMORPH_FIELD"                ] = true,
        ["CHAOTIC_ARC"                          ] = true,
        ["CHARM_ON_TOXIC"                       ] = true,
        ["CIRCLE_ACID"                          ] = true,
        ["CIRCLE_FIRE"                          ] = true,
        ["CIRCLE_OIL"                           ] = true,
        ["CIRCLE_SHAPE"                         ] = true,
        ["CIRCLE_WATER"                         ] = true,
        ["CLIPPING_SHOT"                        ] = true,
        ["CLOUD_ACID"                           ] = true,
        ["CLOUD_BLOOD"                          ] = true,
        ["CLOUD_OIL"                            ] = true,
        ["CLOUD_THUNDER"                        ] = true,
        ["CLOUD_WATER"                          ] = true,
        ["COLOUR_BLUE"                          ] = true,
        ["COLOUR_GREEN"                         ] = true,
        ["COLOUR_INVIS"                         ] = true,
        ["COLOUR_ORANGE"                        ] = true,
        ["COLOUR_PURPLE"                        ] = true,
        ["COLOUR_RAINBOW"                       ] = true,
        ["COLOUR_RED"                           ] = true,
        ["COLOUR_YELLOW"                        ] = true,
        ["CRITICAL_HIT"                         ] = true,
        ["CRUMBLING_EARTH"                      ] = true,
        ["CRUMBLING_EARTH_PROJECTILE"           ] = true,
        ["CURSE"                                ] = true,
        ["CURSED_ORB"                           ] = true,
        ["CURSE_WITHER_ELECTRICITY"             ] = true,
        ["CURSE_WITHER_EXPLOSION"               ] = true,
        ["CURSE_WITHER_MELEE"                   ] = true,
        ["CURSE_WITHER_PROJECTILE"              ] = true,
        ["DAMAGE"                               ] = true,
        ["DAMAGE_FOREVER"                       ] = true,
        ["DAMAGE_RANDOM"                        ] = true,
        ["DARKFLAME"                            ] = true,
        ["DEATH_CROSS"                          ] = true,
        ["DEATH_CROSS_BIG"                      ] = true,
        ["DEATH_TRIGGER"                        ] = true,
        ["DECELERATING_SHOT"                    ] = true,
        ["DELAYED_SPELL"                        ] = true,
        ["DESTRUCTION"                          ] = true,
        ["DIGGER"                               ] = true,
        ["DISC_BULLET"                          ] = true,
        ["DISC_BULLET_BIG"                      ] = true,
        ["DISC_BULLET_BIGGER"                   ] = true,
        ["DIVIDE_10"                            ] = true,
        ["DIVIDE_2"                             ] = true,
        ["DIVIDE_3"                             ] = true,
        ["DIVIDE_4"                             ] = true,
        ["DRAW_3_RANDOM"                        ] = true,
        ["DRAW_RANDOM"                          ] = true,
        ["DRAW_RANDOM_X3"                       ] = true,
        ["DUPLICATE"                            ] = true,
        ["DYNAMITE"                             ] = true,
        ["ELECTRIC_CHARGE"                      ] = true,
        ["ELECTROCUTION_FIELD"                  ] = true,
        ["ENERGY_SHIELD"                        ] = true,
        ["ENERGY_SHIELD_SECTOR"                 ] = true,
        ["ENERGY_SHIELD_SHOT"                   ] = true,
        ["ESSENCE_TO_POWER"                     ] = true,
        ["EXPANDING_ORB"                        ] = true,
        ["EXPLODING_DEER"                       ] = true,
        ["EXPLODING_DUCKS"                      ] = true,
        ["EXPLOSION"                            ] = true,
        ["EXPLOSION_LIGHT"                      ] = true,
        ["EXPLOSION_REMOVE"                     ] = true,
        ["EXPLOSION_TINY"                       ] = true,
        ["EXPLOSIVE_PROJECTILE"                 ] = true,
        ["FIREBALL"                             ] = true,
        ["FIREBALL_RAY"                         ] = true,
        ["FIREBALL_RAY_ENEMY"                   ] = true,
        ["FIREBALL_RAY_LINE"                    ] = true,
        ["FIREBOMB"                             ] = true,
        ["FIREWORK"                             ] = true,
        ["FIRE_BLAST"                           ] = true,
        ["FIRE_TRAIL"                           ] = true,
        ["FIZZLE"                               ] = true,
        ["FLAMETHROWER"                         ] = true,
        ["FLOATING_ARC"                         ] = true,
        ["FLY_DOWNWARDS"                        ] = true,
        ["FLY_UPWARDS"                          ] = true,
        ["FREEZE"                               ] = true,
        ["FREEZE_FIELD"                         ] = true,
        ["FREEZING_GAZE"                        ] = true,
        ["FRIEND_FLY"                           ] = true,
        ["FUNKY_SPELL"                          ] = true,
        ["GAMMA"                                ] = true,
        ["GLITTER_BOMB"                         ] = true,
        ["GLOWING_BOLT"                         ] = true,
        ["GLUE_SHOT"                            ] = true,
        ["GRAVITY"                              ] = true,
        ["GRAVITY_ANTI"                         ] = true,
        ["GRAVITY_FIELD_ENEMY"                  ] = true,
        ["GRENADE"                              ] = true,
        ["GRENADE_ANTI"                         ] = true,
        ["GRENADE_LARGE"                        ] = true,
        ["GRENADE_TIER_2"                       ] = true,
        ["GRENADE_TIER_3"                       ] = true,
        ["GRENADE_TRIGGER"                      ] = true,
        ["GUNPOWDER_TRAIL"                      ] = true,
        ["HEAL_BULLET"                          ] = true,
        ["HEAVY_BULLET"                         ] = true,
        ["HEAVY_BULLET_TIMER"                   ] = true,
        ["HEAVY_BULLET_TRIGGER"                 ] = true,
        ["HEAVY_SHOT"                           ] = true,
        ["HEAVY_SPREAD"                         ] = true,
        ["HITFX_BURNING_CRITICAL_HIT"           ] = true,
        ["HITFX_CRITICAL_BLOOD"                 ] = true,
        ["HITFX_CRITICAL_OIL"                   ] = true,
        ["HITFX_CRITICAL_WATER"                 ] = true,
        ["HITFX_EXPLOSION_ALCOHOL"              ] = true,
        ["HITFX_EXPLOSION_ALCOHOL_GIGA"         ] = true,
        ["HITFX_EXPLOSION_SLIME"                ] = true,
        ["HITFX_EXPLOSION_SLIME_GIGA"           ] = true,
        ["HITFX_PETRIFY"                        ] = true,
        ["HITFX_TOXIC_CHARM"                    ] = true,
        ["HOMING"                               ] = true,
        ["HOMING_ACCELERATING"                  ] = true,
        ["HOMING_AREA"                          ] = true,
        ["HOMING_CURSOR"                        ] = true,
        ["HOMING_ROTATE"                        ] = true,
        ["HOMING_SHOOTER"                       ] = true,
        ["HOMING_SHORT"                         ] = true,
        ["HORIZONTAL_ARC"                       ] = true,
        ["ICEBALL"                              ] = true,
        ["IF_ELSE"                              ] = true,
        ["IF_END"                               ] = true,
        ["IF_ENEMY"                             ] = true,
        ["IF_HALF"                              ] = true,
        ["IF_HP"                                ] = true,
        ["IF_PROJECTILE"                        ] = true,
        ["INFESTATION"                          ] = true,
        ["I_SHAPE"                              ] = true,
        ["KANTELE_A"                            ] = true,
        ["KANTELE_D"                            ] = true,
        ["KANTELE_DIS"                          ] = true,
        ["KANTELE_E"                            ] = true,
        ["KANTELE_G"                            ] = true,
        ["KNOCKBACK"                            ] = true,
        ["LANCE"                                ] = true,
        ["LARPA_CHAOS"                          ] = true,
        ["LARPA_CHAOS_2"                        ] = true,
        ["LARPA_DEATH"                          ] = true,
        ["LARPA_DOWNWARDS"                      ] = true,
        ["LARPA_UPWARDS"                        ] = true,
        ["LASER"                                ] = true,
        ["LASER_EMITTER"                        ] = true,
        ["LASER_EMITTER_CUTTER"                 ] = true,
        ["LASER_EMITTER_FOUR"                   ] = true,
        ["LASER_EMITTER_RAY"                    ] = true,
        ["LASER_EMITTER_WIDER"                  ] = true,
        ["LASER_LUMINOUS_DRILL"                 ] = true,
        ["LAVA_TO_BLOOD"                        ] = true,
        ["LEVITATION_FIELD"                     ] = true,
        ["LIFETIME"                             ] = true,
        ["LIFETIME_DOWN"                        ] = true,
        ["LIGHT"                                ] = true,
        ["LIGHTNING"                            ] = true,
        ["LIGHTNING_RAY"                        ] = true,
        ["LIGHTNING_RAY_ENEMY"                  ] = true,
        ["LIGHT_BULLET"                         ] = true,
        ["LIGHT_BULLET_TIMER"                   ] = true,
        ["LIGHT_BULLET_TRIGGER"                 ] = true,
        ["LIGHT_BULLET_TRIGGER_2"               ] = true,
        ["LIGHT_SHOT"                           ] = true,
        ["LINE_ARC"                             ] = true,
        ["LIQUID_TO_EXPLOSION"                  ] = true,
        ["LONG_DISTANCE_CAST"                   ] = true,
        ["LUMINOUS_DRILL"                       ] = true,
        ["MAGIC_SHIELD"                         ] = true,
        ["MANA_REDUCE"                          ] = true,
        ["MATERIAL_ACID"                        ] = true,
        ["MATERIAL_BLOOD"                       ] = true,
        ["MATERIAL_CEMENT"                      ] = true,
        ["MATERIAL_OIL"                         ] = true,
        ["MATERIAL_WATER"                       ] = true,
        ["MATTER_EATER"                         ] = true,
        ["MEGALASER"                            ] = true,
        ["METEOR"                               ] = true,
        ["METEOR_RAIN"                          ] = true,
        ["MINE"                                 ] = true,
        ["MINE_DEATH_TRIGGER"                   ] = true,
        ["MISSILE"                              ] = true,
        ["MIST_ALCOHOL"                         ] = true,
        ["MIST_BLOOD"                           ] = true,
        ["MIST_RADIOACTIVE"                     ] = true,
        ["MIST_SLIME"                           ] = true,
        ["MONEY_MAGIC"                          ] = true,
        ["MU"                                   ] = true,
        ["NECROMANCY"                           ] = true,
        ["NOLLA"                                ] = true,
        ["NUKE"                                 ] = true,
        ["NUKE_GIGA"                            ] = true,
        ["OCARINA_A"                            ] = true,
        ["OCARINA_A2"                           ] = true,
        ["OCARINA_B"                            ] = true,
        ["OCARINA_C"                            ] = true,
        ["OCARINA_D"                            ] = true,
        ["OCARINA_E"                            ] = true,
        ["OCARINA_F"                            ] = true,
        ["OCARINA_GSHARP"                       ] = true,
        ["OIL_TRAIL"                            ] = true,
        ["OMEGA"                                ] = true,
        ["ORBIT_DISCS"                          ] = true,
        ["ORBIT_FIREBALLS"                      ] = true,
        ["ORBIT_LARPA"                          ] = true,
        ["ORBIT_LASERS"                         ] = true,
        ["ORBIT_NUKES"                          ] = true,
        ["ORBIT_SHOT"                           ] = true,
        ["PEBBLE"                               ] = true,
        ["PENTAGRAM_SHAPE"                      ] = true,
        ["PHASING_ARC"                          ] = true,
        ["PHI"                                  ] = true,
        ["PIERCING_SHOT"                        ] = true,
        ["PINGPONG_PATH"                        ] = true,
        ["PIPE_BOMB"                            ] = true,
        ["PIPE_BOMB_DEATH_TRIGGER"              ] = true,
        ["POISON_BLAST"                         ] = true,
        ["POISON_TRAIL"                         ] = true,
        ["POLLEN"                               ] = true,
        ["POLYMORPH_FIELD"                      ] = true,
        ["POWERDIGGER"                          ] = true,
        ["PROJECTILE_GRAVITY_FIELD"             ] = true,
        ["PROJECTILE_THUNDER_FIELD"             ] = true,
        ["PROJECTILE_TRANSMUTATION_FIELD"       ] = true,
        ["PROPANE_TANK"                         ] = true,
        ["PURPLE_EXPLOSION_FIELD"               ] = true,
        ["QUANTUM_SPLIT"                        ] = true,
        ["RAINBOW_TRAIL"                        ] = true,
        ["RANDOM_EXPLOSION"                     ] = true,
        ["RANDOM_MODIFIER"                      ] = true,
        ["RANDOM_PROJECTILE"                    ] = true,
        ["RANDOM_SPELL"                         ] = true,
        ["RANDOM_STATIC_PROJECTILE"             ] = true,
        ["RECHARGE"                             ] = true,
        ["RECOIL"                               ] = true,
        ["RECOIL_DAMPER"                        ] = true,
        ["REGENERATION_FIELD"                   ] = true,
        ["REMOVE_BOUNCE"                        ] = true,
        ["RESET"                                ] = true,
        ["ROCKET"                               ] = true,
        ["ROCKET_DOWNWARDS"                     ] = true,
        ["ROCKET_OCTAGON"                       ] = true,
        ["ROCKET_TIER_2"                        ] = true,
        ["ROCKET_TIER_3"                        ] = true,
        ["RUBBER_BALL"                          ] = true,
        ["SCATTER_2"                            ] = true,
        ["SCATTER_3"                            ] = true,
        ["SCATTER_4"                            ] = true,
        ["SEA_ACID"                             ] = true,
        ["SEA_ACID_GAS"                         ] = true,
        ["SEA_ALCOHOL"                          ] = true,
        ["SEA_LAVA"                             ] = true,
        ["SEA_OIL"                              ] = true,
        ["SEA_WATER"                            ] = true,
        ["SHIELD_FIELD"                         ] = true,
        ["SIGMA"                                ] = true,
        ["SINEWAVE"                             ] = true,
        ["SLIMEBALL"                            ] = true,
        ["SLOW_BULLET"                          ] = true,
        ["SLOW_BULLET_TIMER"                    ] = true,
        ["SLOW_BULLET_TRIGGER"                  ] = true,
        ["SLOW_BUT_STEADY"                      ] = true,
        ["SOILBALL"                             ] = true,
        ["SPEED"                                ] = true,
        ["SPELLS_TO_POWER"                      ] = true,
        ["SPIRAL_SHOT"                          ] = true,
        ["SPIRALING_SHOT"                       ] = true,
        ["SPITTER"                              ] = true,
        ["SPITTER_TIER_2"                       ] = true,
        ["SPITTER_TIER_2_TIMER"                 ] = true,
        ["SPITTER_TIER_3"                       ] = true,
        ["SPITTER_TIER_3_TIMER"                 ] = true,
        ["SPITTER_TIMER"                        ] = true,
        ["SPORE_POD"                            ] = true,
        ["SPREAD_REDUCE"                        ] = true,
        ["STATIC_TO_SAND"                       ] = true,
        ["SUMMON_EGG"                           ] = true,
        ["SUMMON_HOLLOW_EGG"                    ] = true,
        ["SUMMON_PORTAL"                        ] = true,
        ["SUMMON_ROCK"                          ] = true,
        ["SUMMON_WANDGHOST"                     ] = true,
        ["SUPER_TELEPORT_CAST"                  ] = true,
        ["SWAPPER_PROJECTILE"                   ] = true,
        ["SWARM_FIREBUG"                        ] = true,
        ["SWARM_FLY"                            ] = true,
        ["SWARM_WASP"                           ] = true,
        ["T_SHAPE"                              ] = true,
        ["TAU"                                  ] = true,
        ["TELEPORT_CAST"                        ] = true,
        ["TELEPORT_PROJECTILE"                  ] = true,
        ["TELEPORT_PROJECTILE_CLOSER"           ] = true,
        ["TELEPORT_PROJECTILE_SHORT"            ] = true,
        ["TELEPORT_PROJECTILE_STATIC"           ] = true,
        ["TELEPORTATION_FIELD"                  ] = true,
        ["TEMPORARY_PLATFORM"                   ] = true,
        ["TEMPORARY_WALL"                       ] = true,
        ["TENTACLE"                             ] = true,
        ["TENTACLE_PORTAL"                      ] = true,
        ["TENTACLE_RAY"                         ] = true,
        ["TENTACLE_RAY_ENEMY"                   ] = true,
        ["TENTACLE_TIMER"                       ] = true,
        ["THUNDER_BLAST"                        ] = true,
        ["THUNDERBALL"                          ] = true,
        ["ADD_TIMER"                            ] = true,
        ["TINY_GHOST"                           ] = true,
        ["TNTBOX"                               ] = true,
        ["TNTBOX_BIG"                           ] = true,
        ["TORCH"                                ] = true,
        ["TORCH_ELECTRIC"                       ] = true,
        ["TOUCH_ALCOHOL"                        ] = true,
        ["TOUCH_BLOOD"                          ] = true,
        ["TOUCH_GOLD"                           ] = true,
        ["TOUCH_OIL"                            ] = true,
        ["TOUCH_SMOKE"                          ] = true,
        ["TOUCH_WATER"                          ] = true,
        ["TOXIC_TO_ACID"                        ] = true,
        ["TRANSMUTATION"                        ] = true,
        ["ADD_TRIGGER"                          ] = true,
        ["UNSTABLE_GUNPOWDER"                   ] = true,
        ["VACUUM_ENTITIES"                      ] = true,
        ["VACUUM_LIQUID"                        ] = true,
        ["VACUUM_POWDER"                        ] = true,
        ["W_SHAPE"                              ] = true,
        ["WALL_HORIZONTAL"                      ] = true,
        ["WALL_SQUARE"                          ] = true,
        ["WALL_VERTICAL"                        ] = true,
        ["WATER_TO_POISON"                      ] = true,
        ["WATER_TRAIL"                          ] = true,
        ["WORM_SHOT"                            ] = true,
        ["WORM_RAIN"                            ] = true,
        ["X_RAY"                                ] = true,
        ["Y_SHAPE"                              ] = true,
        ["ZETA"                                 ] = true,
        -- add action IDs here
    }

    for i=1, #actions do
        if actions_to_edit[actions[i].id] then
            actions[i].sprite = table.concat{path, actions[i].id, ".png"}
        end
    end

    -- Prepared by Copi (Human#6606)
end